Public Class Form1
    'declaramos una variable de tipo HashTable
    Dim tabla As New Hashtable
    Sub ActualizarTabla()
        Dim elemento As New DictionaryEntry
        Dim Fila% = 0
        For Each elemento In tabla
            ListView1.Items.Add(elemento.Key)
            ListView1.Items(Fila).SubItems.Add(elemento.Value)
            Fila += 1
        Next
    End Sub
    Sub Agregar()
        Try
            tabla.Add(TextBox1.Text, TextBox2.Text)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        btnAgregar.Enabled = False
        TextBox2.Text = ""
        TextBox1.Focus()
    End Sub
    Private Sub btnAgregar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAgregar.Click
        Agregar()
    End Sub

    Sub Buscar()
        Dim valor As String
        'Si el hashTable contiene lo digitado en TextBox1.Text
        If tabla.ContainsKey(TextBox1.Text) = True Then
            'valor obtiene el value de la tabla segn el ndice de TextBox1.Text
            valor = tabla(TextBox1.Text)
            TextBox2.Text = valor
            btnAgregar.Enabled = False
            btnModificar.Enabled = True
            btnEliminar.Enabled = True
        Else
            btnAgregar.Enabled = True
            btnModificar.Enabled = False
            btnEliminar.Enabled = False
        End If
        TextBox2.Focus()
    End Sub

    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        If Asc(e.KeyChar) = 13 Then Buscar()
    End Sub
    Sub Eliminar()
        Try
            tabla.Remove(TextBox1.Text)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        btnEliminar.Enabled = False
        btnModificar.Enabled = False
    End Sub
    Private Sub btnModificar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnModificar.Click
        Eliminar()
        Agregar()
    End Sub

    Private Sub btnEliminar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEliminar.Click
        Eliminar()
        TextBox1.Focus()
        TextBox2.Text = ""
    End Sub

    Private Sub btnCerrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCerrar.Click
        End
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.CheckState = CheckState.Checked Then
            ActualizarTabla()
        Else
            ListView1.Items.Clear()
        End If
    End Sub
End Class
